<?php
// Graphs Package V2.1 16th March 2008
// Sunspot for current year
// Version 1.00 - 17 Oct 2010 -- Intial release
// Version 1.10 - 15 Oct 2010 -- major rewrite
// Version 1.20 - 1 Jan 2011 -- Changes to allow for new year
// Version 1.30 - 12 Jan 2014 -- 
// www.newquayweather.com

// Installation
// Upload to wxgraphs, you must have jpgraphs installed
// Change paths to match your website if needed
// The background image can be changed by changing $bgimageurl
// can be called with <img src="wxgraphs/sunspots-year.php">
//
// **** Known Issue ****
// 1st Jan to the 3rd of Jan there is no data for graph, you can amend line to show last years and
// comment out  again on 3rd jan
// see line $curyear="2014";  // new year Jan 1st to 3rd, no data yet use last year
// 
// Please mention newquayweather

if (!file_exists("graphsconf.php")) include("error_msg.php");
include ("graphsconf.php");
if (!file_exists($jploc."jpgraph.php")) {
  $string = "Unable to find JPGraph files";
  create_image1($string,$jploc);
  exit;
}

include ($jploc."jpgraph.php");
// Comment out one
//include ($jploc."jpgraph_bar.php");
include ($jploc."jpgraph_line.php");

// Paths to data 
 $curyear=date("Y");
// $curyear="2014";  // new year Jan 1st to 3rd, no data yet use last year
 $aa=("/home/xxxxx/public_html/xxxxx/sunspots/".$curyear."/".$curyear."_DSD.txt");
 
// The background image can be changed by changing $bgimageurl, choose only one
//
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/hmi_igr/512/latest.jpg"; // background MDI image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/synoptic/sunspots_earth/mdi_sunspots.jpg"; // background image to graphs
//   $bgimageurl="http://sohowww.nascom.nasa.gov/data/realtime/hmi_mag/512/latest.jpg"; // HMI Magnetogram Image
   $bgimageurl="https://soho.nascom.nasa.gov/data/synoptic/sunspots_earth/mdi_sunspots.jpg"; // Updated 11-4-2022

$bgimage="/home/xxxxx/public_html/xxxxx/sunspots/bgyearimage.jpg";
 
 $refetchSeconds = 3600; // 1 hour

if (file_exists($bgimage) and filemtime($bgimage) + $refetchSeconds > time()) {
//      echo "<!-- using Cached version of jpg -->\n";
  $bgimage = "/home/xxxxx/public_html/xxxxx/sunspots/bgyearimage.jpg";
    } else {
    	
 $ch = curl_init($bgimageurl);
$fp = fopen($bgimage, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);
fclose($fp);


//  save_image($bgimageurl, $bgimage); 
//      echo "<!-- loading finished. -->\n";
	}

// arrays
$y = array();
$a = array();

readsunspotfile($aa,$a,$y);

// Here we create an aray for the y-values
//$y = array(fgets($handle[$yy]));
//=================================================================================================
//here we create the labels for the x-axis depending month and year
//so if we are in March we must show the last day of Feb normally 28 or 29 and the following
//label must be 01
//same for moths with 30 days (last day = 30 next label must be 01 and not 31
//we need 31 labels because we have 31 datapoints
//==================================================================================================
//
// Create the graph. These two calls are always required
$graph = new Graph(512,572,"auto",30);	
$graph->SetScale("textlin");
$graph->yscale->SetGrace(2);
$graph->SetMargin(25,20,25,80);
$graph->ygrid->Show(false); 
//$graph->SetShadow();  //uncomment to add shadow

// Graph colors
$graph->SetBackgroundGradient('black','black',GRAD_HOR,BGRAD_PLOT);
$graph->SetMarginColor("black");
$graph->SetFrame(true,'black',1);


// Comment out this if you want bar graph
// Only one should be un commented
// Create a line plot
$lplot = new LinePlot($y);
$lplot->SetColor('orange'); // color of y-axis graph line
$lplot->SetWeight(2);
//$lplot->SetFillColor('green'); 
$graph->Add($lplot);
$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);
// End comment out

// Comment out this if you want line graph
// Create a bar plot
//$bplot = new BarPlot($y);
//$bplot->SetWidth(0.7);
//$bplot->SetFillColor("$sunspot_col");
//$graph->Add($bplot);
//$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);
// End comment out

// Setup the titles
$graph->title->SetFont(FF_ARIAL,FS_BOLD,12);
$graph->title->Set("Sunspots - ".$curyear);
$graph->title->SetColor("orange"); 


//x-axis
$graph->xaxis->title->SetFont(FF_ARIAL,FS_BOLD,10);
$graph->xaxis->title->SetColor("$xtextcolour");
$graph->xaxis->SetTickLabels($a); 
$graph->xaxis->SetLabelAngle(80);
$graph->xaxis->SetLabelMargin(5); 
$graph->xaxis->SetTextLabelInterval(8);
$graph->xaxis->SetPos("min"); 
$graph->xaxis->SetFont(FF_ARIAL,FS_BOLD,8); 
$graph->xaxis->SetColor("$xtextcolour");
$graph->xaxis->HideTicks(true,false); 
$graph->xaxis->SetTickSide(SIDE_BOTTOM); 
$graph->xaxis->SetColor('white','orange'); 

//y-axis
$graph->yaxis->SetFont(FF_ARIAL,FS_BOLD,8);
$graph->yaxis->scale->SetGrace(5);
$graph->yaxis->scale->SetAutoMin(0);
$graph->yaxis->SetLabelMargin(5); 
$graph->yaxis->SetColor('white','orange'); 

// Display the graph
$graph->Stroke();


// ----------------------------functions ----------------------------------- 

function readsunspotfile($aFile, &$aYears, &$aSunspots) {
	    $lines = @file($aFile,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
    if( $lines === false ) {
        throw new JpGraphException('Can not read sunspot data file.');
    }

   foreach( $lines as $line => $datarow ) {
//     $split = preg_split("/[\n]/", $datarow, -1, 0);

 $last = preg_replace('/\s\s+/', ' ', $datarow)."\n";
 $dayspots = explode(" ", $last);
 $yr = $dayspots[0]; // year
 $mth = $dayspots[1]; // month
 $dy = $dayspots[2]; // day
 $spots = $dayspots[4]; // spots
 $aYears[] = $dy."-".$mth."-".$yr;
 $aSunspots[] = $spots;
    }
}

// --------------end of functions ---------------------------------------
?>
